/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.collections.adapters;

import java.util.Iterator;

/**
 * Adapts Iterable&lt;E1&gt; to Iterable&lt;E2&gt; using conversion function
 * convert 
 * @author borisman
 */
public abstract class IterableAdapter<E1, E2> implements Iterable<E2> {
	
	private final Iterable<E1> backend;
	
	public IterableAdapter(final Iterable<E1> backend) {
		this.backend = backend;
	}
	
	@Override public Iterator<E2> iterator() {
		return new IteratorAdapter<E1, E2>(backend.iterator()){
			@Override protected E2 convert(final E1 e) {
				return IterableAdapter.this.convert(e);
			}};
	}
	
	protected abstract E2 convert(final E1 e);
	
}
