/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.testing.webmock;

import org.builtu.exceptions.FatalError;
import org.builtu.testing.webmock.WebMock;


public abstract class AbstractWebMockTest {
	public static final int START_PORT = 8080;
	public static final int END_PORT = 9000;
	
	public static volatile int port=START_PORT; 
	
	protected WebMock mock;
	
	protected void startMock() throws Exception {
		while(true) {
			try {
				mock.start(port);
				break;
			} catch (final java.net.BindException e) {
				if (++port > END_PORT) throw new FatalError(e);
			}
		}
	}
	
	protected static String host() {
		return "http://localhost:"+port;
	}
}
