package org.builtu;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Date;

import junit.framework.Assert;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class TestJdbcStatListener {
	
	private JdbcStatListener listener;
	
	@Before public void create() {
		listener = new JdbcStatListener();
	}
	
	@After public void close() {
		listener.close();
	}
	
	@Test public void testSimple() throws SQLException {
		listener.listen(new Date(), new Date(), 1);
		
		final Connection conn = listener.getConnection();
		try {
			final Statement stmt = conn.createStatement();
			final ResultSet rst = stmt.executeQuery("SELECT SUM(sessions) FROM WebStat;");
			Assert.assertTrue(rst.next());
			final int count = rst.getInt(1);
			Assert.assertTrue(count>0);
		} finally {
			conn.close();
		}
	}
}
